--Based on SimpleHome by supertransformer--

homeDir = 'Plugins/MyHomes' 

function Initialize(Plugin)
	Plugin:SetName("MyHomes")
	Plugin:SetVersion(1)
	PluginManager = cRoot:Get():GetPluginManager()
	PluginManager:BindCommand("/home","myhomes.home",HandleHomeCommand," - Go Home!")
	PluginManager:BindCommand("/sethome","myhomes.sethome",HandleSetHomeCommand," - Set your home!")
	PluginManager:BindCommand("/home2","myhomes.home2",HandleHome2Command," - Go Home!")
	PluginManager:BindCommand("/sethome2","myhomes.sethome2",HandleSetHome2Command," - Set your home!")
	PluginManager:BindCommand("/home3","myhomes.home3",HandleHome3Command," - Go Home!")
	PluginManager:BindCommand("/sethome3","myhomes.sethome3",HandleSetHome3Command," - Set your home!")
	LOGINFO("Initialized " .. Plugin:GetName() .. " v." .. Plugin:GetVersion())
	return true;
end

function HandleHomeCommand(Split, Player)
	goHome(Player)
	return true
end

function HandleSetHomeCommand(Split, Player)
	setHome(Player)
	return true
end

function goHome(Player)
		username = Player:GetName()
		coords = lines_from(homeDir..'/'..username..'.home')
		Player:SendMessage(cChatColor.Green .. 'Teleporting you to home...')
		Player:TeleportToCoords(coords[1], coords[2], coords[3])
		if Player:GetWorld():GetName() ~= coords[4] then
		    Player:MoveToWorld(coords[4])
		end
		return true
end

function setHome(Player)
		username = Player:GetName()
		homeX = Player:GetPosX()
		homeY = Player:GetPosY()
		homeZ = Player:GetPosZ()
		local file = io.open(homeDir..'/'..username..'.home', "w")
		file:write(homeX..'\n'..homeY..'\n'..homeZ..'\n'..Player:GetWorld():GetName())
		file:close()
		Player:SendMessage(cChatColor.Green .. 'Home set! use /home to go home!')
		
	return true
end

function HandleHome2Command(Split, Player)
	goHome2(Player)
	return true
end

function HandleSetHome2Command(Split, Player)
	setHome2(Player)
	return true
end

function goHome2(Player)
		username = Player:GetName()
		coords = lines_from(homeDir..'/'..username..'.home2')
		Player:SendMessage(cChatColor.Green .. 'Teleporting you to home...')
		Player:TeleportToCoords(coords[1], coords[2], coords[3])
		if Player:GetWorld():GetName() ~= coords[4] then
		    Player:MoveToWorld(coords[4])
		end
		return true
end

function setHome2(Player)
		username = Player:GetName()
		homeX = Player:GetPosX()
		homeY = Player:GetPosY()
		homeZ = Player:GetPosZ()
		local file = io.open(homeDir..'/'..username..'.home2', "w")
		file:write(homeX..'\n'..homeY..'\n'..homeZ..'\n'..Player:GetWorld():GetName())
		file:close()
		Player:SendMessage(cChatColor.Green .. 'Home set! use /home2 to go home!')
	    return true
end

function HandleHome3Command(Split, Player)
	goHome3(Player)
	return true
end

function HandleSetHome3Command(Split, Player)
	setHome3(Player)
	return true
end

function goHome3(Player)
		username = Player:GetName()
		coords = lines_from(homeDir..'/'..username..'.home3')
		Player:SendMessage(cChatColor.Green .. 'Teleporting you to home...')
		Player:TeleportToCoords(coords[1], coords[2], coords[3])
		if Player:GetWorld():GetName() ~= coords[4] then
		    Player:MoveToWorld(coords[4])
		end
		return true
end

function setHome3(Player)
		username = Player:GetName()
		homeX = Player:GetPosX()
		homeY = Player:GetPosY()
		homeZ = Player:GetPosZ()
		local file = io.open(homeDir..'/'..username..'.home3', "w")
		file:write(homeX..'\n'..homeY..'\n'..homeZ..'\n'..Player:GetWorld():GetName())
		file:close()
		Player:SendMessage(cChatColor.Green .. 'Home 3 set! use /home3 to go home!')
		
	return true
end

function file_exists(file)
  local f = io.open(file, "rb")
  if f then f:close() end
  return f ~= nil
end

function lines_from(file)
  if not file_exists(file) then return {} end
  lines = {}
  for line in io.lines(file) do 
    lines[#lines + 1] = line
  end
  return lines
end